/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "fe/data.h"

class myClass
{
	public:
		myClass(void) { m_int = 1; }
virtual	~myClass(void) { }

virtual	bool operator==(const myClass &other) const
		{
			return (m_int == other.m_int);
		}

		int	m_int;
};


int main(void)
{
	fe::UnitTest unitTest;
	try
	{

// deprecated usage model.  don't do this.  create your attributes via scopes
#if 0
		fe::sp<fe::BaseType> spMyClassType(new fe::Type<myClass>);

		fe::sp<fe::TypeMaster> spTypeMaster(new fe::TypeMaster());

		fe::sp<fe::Attribute> myAttribute(new fe::Attribute("my_attribute",
				spMyClassType, spTypeMaster));
#endif

		fe::sp<fe::Master> spMaster(new fe::Master);
		fe::sp<fe::Scope> spScope(new fe::Scope(*spMaster.raw()));

		spScope->typeMaster()-> assertType<myClass>("myClassType");
		fe::sp<fe::Attribute> myAttribute =
			spScope->support("my_attribute", "myClassType");

		fe::Peeker peek;
		peek(*myAttribute);
		feLog("%s\n",peek.output().c_str());

	}
	catch(fe::Exception &e)
	{
		e.log();
	}

	return unitTest.failures();
}
